/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria		*
*									*
* Permission to use, copy, modify, and distribute this material for any	*
* purpose and without fee is hereby granted, provided that the above	*
* copyright notice and this permission notice appear in all copies, and	*
* that the name of the author not be used in advertising or publicity 	*
* pertaining to this material without the specific, prior written 	*
* permission of the author.						*
*									*
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY	*  
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY	* 
* EXPRESS OR IMPLIED WARRANTIES.					*
*************************************************************************/

/**************************ciilib1.2.1***********************************
 *                                                                      *
 *        Character to Inline Image Conversion Library (CIILIB)         *
 *                                                                      *
 *    JIS-X-0208-XXXX 16x16 BDF Font to CIILIB XBM source convertor.	*
 *              	by Valentin Shopov		                *
 *			valentin@rs.aubg.bg				*
 ************************************************************************/





#include <stdio.h>
#include <string.h>

char curcol[2048],currow[2048];
int KANIND[94*94];

char *getcol(row,numcol)
char *row;
int numcol;
{
int i,j,k;
char *tmpcol;
	if(numcol<=0) return row;
	tmpcol=curcol;
	for(i=0,j=0,k=0;row[i]!='\n';i++){
	  if(row[i]==' ' || row[i]=='\t'){
		 if(j){
			tmpcol[j]='\0';
			j=0;
			if(++k==numcol) return tmpcol;
		 }
		 continue;
	  }
	tmpcol[j++]=row[i];
	}
	if(k==numcol-1){
	tmpcol[j]='\0';
	}
	else tmpcol[0]='\0';
	return tmpcol;	
}

mirror(src) 
char *src;
{
int bmrow,i,lbit=0x0001,hbit=0x0080,hlbit=0x0100,hhbit=0x8000,dst;
sscanf(src,"%04x",&bmrow);
	for(i=0,dst=0;i<8;i++){
	dst|=(lbit & bmrow)? hbit : 0;
	dst|=(hlbit & bmrow)? hhbit : 0;
	lbit <<= 1;
	hbit >>= 1;
	hlbit <<= 1;
	hhbit >>= 1;
	}
return dst;
}


main(ac,av)
char *av[];
{
int XBMPOS=0,NOFCH,NOFB,EUC,ROW,KINROW,BMB=0,cnvtb,x;
char *row;
FILE *dstf,*srcf;
	if( ac < 2 ){
                fprintf(stderr,"Usage: %s  <JIS-X-0208-XXXX-16x16-bdf-file-name>\n",av[0]);
                exit(1);
        }

row=currow;
printf("Creating \"_xbmraw.c\"...\n");
	for (x=0; x < 94*94; x++){
	KANIND[x] = -1;}
dstf = fopen("_xbmraw.c","w+");
	if(dstf==NULL){
		fprintf(stderr,"Error opening \"_xbmraw.c\"!");
                exit(1);
	}		
srcf = fopen(av[1],"r");
        if(srcf==NULL){
                fprintf(stderr,"Error opening \"%s\"!",av[1]);
                exit(1);
        }               

fprintf(dstf,"char *xbmsrc[] = {\n"); 
for(;fgets(row,2048,srcf)!=NULL;){
	if(!XBMPOS){

	if(!strcmp("FONTBOUNDINGBOX",getcol(row,1))) {
		if (atoi(getcol(row,2)) != 16 || atoi(getcol(row,3)) != 16) {
		printf("This BDF font is not 16x16 size !!!\n");
		exit(1); }
	}

	if(!strcmp("CHARS",getcol(row,1))) {
	NOFCH = atoi(getcol(row,2));
	}

	}

	if(!strcmp("ENCODING",getcol(row,1))) {
	NOFB = 0;
	EUC = atoi(getcol(row,2)) + 32896 ;
	fprintf(dstf,"/* %x EUC */\n\"\\\n",EUC);
	ROW = EUC/256-161;
	KINROW = EUC%256-161;
	KANIND[ROW*94+KINROW]=XBMPOS++;
	}

	if(!strcmp("ENDCHAR",getcol(row,1))) {
	BMB = 0;
	fprintf(dstf,"\",\n");
	printf("Completed...  %d%%\r",(XBMPOS*100)/NOFCH); 
	}


	if(BMB) {
		if(NOFB) {
		fprintf(dstf,"\\\n");
		}
	cnvtb=mirror(getcol(row,1));
	fprintf(dstf,"\\%03o\\%03o",cnvtb/256,cnvtb%256);
	NOFB = 1;
	}

	if(!strcmp("BITMAP",getcol(row,1))) BMB=1;

}

	fprintf(dstf,"0};\n");
	fprintf(dstf,"int xbmind[] = {\n");
	for(x=0; x< 94*94; x++){
	fprintf(dstf,"%d,",KANIND[x]);
	if(x%10==9) fprintf(dstf,"\n");
	}
	fprintf(dstf,"0};\n");
	fclose(dstf);
	fclose(srcf);
	if(NOFCH!=XBMPOS){
		printf("\nSomething wrong! Please check your BDF file!\n");
		exit(1);
	}
	printf("\nNumber of defined chars: %d\nNumber of processed chars: %d\nDone with creating \"_xbmraw.c\".\n",NOFCH,XBMPOS);
exit(0);
}
